diff --git a/src/postgres/src/test/regress/expected/yb_hash_code.out b/src/postgres/src/test/regress/expected/yb_hash_code.out
index c90ec98770d6..2e4b073c0fcb 100644
--- a/src/postgres/src/test/regress/expected/yb_hash_code.out
+++ b/src/postgres/src/test/regress/expected/yb_hash_code.out
@@ -933,3 +933,21 @@ SELECT v1, yb_hash_code(v4) FROM test_index_only_scan_recheck WHERE v4 IN (1, 2,
 (2 rows)
 
 DROP TABLE test_index_only_scan_recheck;
+-- Issue #17043
+CREATE TABLE t as select x, x as y from generate_series(1, 10) x;
+CREATE INDEX t_x_hash_y_asc_idx ON t (x HASH, y ASC);
+EXPLAIN (ANALYZE, COSTS OFF, SUMMARY OFF, TIMING OFF) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+                                 QUERY PLAN
+-----------------------------------------------------------------------------
+ Index Only Scan using t_x_hash_y_asc_idx on t (actual rows=1 loops=1)
+   Index Cond: ((yb_hash_code(x) = 2675) AND (y = ANY ('{5,6}'::integer[])))
+   Heap Fetches: 0
+(3 rows)
+
+SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+ yb_hash_code | y 
+--------------+---
+         2675 | 5
+(1 row)
+
+DROP TABLE t;
diff --git a/src/postgres/src/test/regress/sql/yb_hash_code.sql b/src/postgres/src/test/regress/sql/yb_hash_code.sql
index c5b709c03d67..af7750953a9c 100644
--- a/src/postgres/src/test/regress/sql/yb_hash_code.sql
+++ b/src/postgres/src/test/regress/sql/yb_hash_code.sql
@@ -200,3 +200,10 @@ EXPLAIN (COSTS OFF, TIMING OFF, SUMMARY OFF, ANALYZE) SELECT v1, yb_hash_code(v4
 SELECT v1, yb_hash_code(v4) FROM test_index_only_scan_recheck WHERE v4 IN (1, 2, 3) AND yb_hash_code(v4) < 50000;
 
 DROP TABLE test_index_only_scan_recheck;
+
+-- Issue #17043
+CREATE TABLE t as select x, x as y from generate_series(1, 10) x;
+CREATE INDEX t_x_hash_y_asc_idx ON t (x HASH, y ASC);
+EXPLAIN (ANALYZE, COSTS OFF, SUMMARY OFF, TIMING OFF) SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+SELECT yb_hash_code(x), y FROM t WHERE yb_hash_code(x) = 2675 AND y IN (5, 6);
+DROP TABLE t;
diff --git a/src/yb/docdb/doc_pgsql_scanspec.cc b/src/yb/docdb/doc_pgsql_scanspec.cc
index a023ce16cd0e..ca60ede846ed 100644
--- a/src/yb/docdb/doc_pgsql_scanspec.cc
+++ b/src/yb/docdb/doc_pgsql_scanspec.cc
@@ -358,12 +358,16 @@ KeyBytes DocPgsqlScanSpec::bound_key(const Schema& schema, const bool lower_boun
   auto encoder = dockv::DocKeyEncoder(&result).Schema(schema);
 
   bool has_hash_columns = schema.num_hash_key_columns() > 0;
+
+  // The first column in a hash partitioned table is the hash code column.
+  bool has_in_hash_options = has_hash_columns && options_ && !options_->empty()
+      && !(*options_)[schema.get_dockey_component_idx(0)].empty();
   dockv::KeyEntryValues hashed_components;
   hashed_components.reserve(schema.num_hash_key_columns());
 
   int32_t hash_code;
   int32_t max_hash_code;
-  if (hashed_components_->empty() && has_hash_columns && options_ && !options_->empty()) {
+  if (hashed_components_->empty() && has_in_hash_options) {
     for (size_t i = 0; i < schema.num_hash_key_columns(); ++i) {
       DCHECK_GE(options_->size(),
                 schema.num_hash_key_columns() + schema.has_yb_hash_code());
